
Ruby - Bug #12878

0.49999999999999994.round is 1 and not 0 on Windows 64

10/28/2016 12:28 PM - Eregon (Benoit Daloze)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.3.1p112 (2016-04-26 revision

54768) [x64-mingw32]

Backport: 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3:

UNKNOWN

Description

0.49999999999999994.round produces 1 on this platform, while all other platforms seem to produce the expected 0

(round-to-nearest).

Maybe this is due to some slightly different floating-point representation?

See https://ci.appveyor.com/project/eregon/spec-x948i/build/190/job/jk8eb1u2kq6npwn4 which reproduced it in a run of ruby/spec.

Associated revisions

Revision 1e63aafe773b3cc12e0be4fb737a423b4a1338e6 - 10/31/2016 04:31 PM - nobu (Nobuyoshi Nakada)

configure.in: no round in x64-mingw

configure.in (ac_cv_func_round): round(3) in x86_64-w64-mingw32

is not accurate in an edge case.  [ruby-core:77794] [Bug #12878]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56534 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1e63aafe - 10/31/2016 04:31 PM - nobu (Nobuyoshi Nakada)

configure.in: no round in x64-mingw

configure.in (ac_cv_func_round): round(3) in x86_64-w64-mingw32

is not accurate in an edge case.  [ruby-core:77794] [Bug #12878]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56534 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/31/2016 06:22 AM - shyouhei (Shyouhei Urabe)

JFYI if we stick to 64bit representation, 0.49999999999999994 is 0011111111011111111111111111111111111111111111111111111111111111.

#2 - 10/31/2016 04:31 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r56534.

configure.in: no round in x64-mingw

configure.in (ac_cv_func_round): round(3) in x86_64-w64-mingw32

is not accurate in an edge case.  [ruby-core:77794] [Bug #12878]
